% @author: Wenqiang Yan

% This code is used for the maximum contrast fusion

clc
close all
clear all
feature jit off % Accelerate code run
DATA = load('...\MATLAB Code\data_test.mat'); %Import mate file format: Sampling points*channel*trial
Fs=1200;% sampling frequency
nn=5; %Stimulus duration of each trial
t = (0:1/Fs:(nn*Fs-1)/Fs)';
fps=[7 8 9 10 7.2 8.2 9.2 10.2 7.4 8.4 9.4 10.4 7.6 8.6 9.6 10.6 7.8 8.8 9.8 10.8]; % stimulus frequency

for i=1:20 % 20 targets
    for k=1:6
        a=DATA.data(:,k,i);
        aa=detrend(a,'constant');
        aaa=smooth(aa,30,'loess');
        b(:,k)=bandp(aaa,0.5,50,0.2,60,Fs); %Chebyshev band pass filtering
    end
    
    % The parameters of Welch power spectrum
    Nfft=length(b);
    noverlap=256;
    dflag='onesided';
    window=gausswin(length(b)); %˹
    
    % maximum contrast fusion
    B = b;
    for ii=1:20
        rad1=pi*fps(ii)*t*2;
        cos2=cos(rad1);
        sin2=sin(rad1);       
        X1=[cos2 sin2];
        Y1=B-X1/(X1'*X1)*X1'*B;% the noise energy
        [V2, D2]=eig(B'*B,Y1'*Y1);
        signal2=B*(V2(:,6));% fusion     
        [Pxx3,f3]=pwelch(signal2,window,noverlap,Nfft,Fs,dflag);
        K3(ii)=Pxx3(nn*fps(ii)+1,1);
    end
    
    % Identify the target frequency
    [c1,c2(1,i)]=max(K3); % The frequency corresponding to the highest amplitude is identified as the focused target frequency
    
end
KKK=1:1:20;
Number=length(find((c2-KKK)==0)) % Output the number of targets that were correctly identified



